@REM ŏ̒:: gDC[
@REM |Wg:: $Id: archive-all.bat 71 2011-05-22 13:01:14Z yutaka_at_home $
@REM 쌠:: Copyright (C) Ownway.info, 2011. All rights reserved.
@REM CZX:: CPL(Common Public Licence)

@SETLOCAL

@ECHO OFF

REM --------------------------------------------------
REM O
REM --------------------------------------------------

SET OUT_DIR=Output
SET OUT_BIN_DIR=%OUT_DIR%\bin
SET OUT_INCLUDE_DIR=%OUT_DIR%\include
SET OUT_LIB_DIR=%OUT_DIR%\lib
SET OUT_SAMPLE_DIR=%OUT_DIR%\sample

SET STDOUT=stdout.log
SET STDERR=stderr.log

DEL %STDOUT% 2> nul
DEL %STDERR% 2> nul

rmdir /S /Q %OUT_DIR% >> "%STDOUT%" 2>> "%STDERR%"
mkdir %OUT_BIN_DIR% >> "%STDOUT%" 2>> "%STDERR%"
mkdir %OUT_INCLUDE_DIR% >> "%STDOUT%" 2>> "%STDERR%"
mkdir %OUT_LIB_DIR% >> "%STDOUT%" 2>> "%STDERR%"
mkdir %OUT_SAMPLE_DIR% >> "%STDOUT%" 2>> "%STDERR%"

ECHO [%DATE% %TIME%] BUILD START ...

CALL "%VC_HOME%\vcvarsall.bat" >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

REM --------------------------------------------------
REM C
REM --------------------------------------------------

COPY readme.txt %OUT_DIR% >> "%STDOUT%" 2>> "%STDERR%"

CALL :ARCHIVE_LIBRARY core
CALL :ARCHIVE_LIBRARY grammar
CALL :ARCHIVE_LIBRARY processor
CALL :ARCHIVE_LIBRARY view
CALL :ARCHIVE_LIBRARY sapi
CALL :ARCHIVE_LIBRARY engine-factory

CALL :ARCHIVE_APPLICATION helloworld
CALL :ARCHIVE_APPLICATION calculator1

REM --------------------------------------------------
REM ㏈
REM --------------------------------------------------

ECHO [%DATE% %TIME%] BUILD SUCCEESSED ...

EXIT /B 0

REM --------------------------------------------------
REM CũrhRs[
REM --------------------------------------------------

:ARCHIVE_LIBRARY

SET PACKAGE=%1
ECHO [%DATE% %TIME%] ARCHIVE LIBRARY START  %PACKAGE%

REM rh
msbuild ..\..\main\%PACKAGE%\spcf-%PACKAGE%.vcxproj /t:Clean;Build /p:configuration=DEBUG   >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
msbuild ..\..\main\%PACKAGE%\spcf-%PACKAGE%.vcxproj /t:Clean;Build /p:configuration=RELEASE >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

REM Rs[
XCOPY /E ..\..\main\%PACKAGE%\include "%OUT_INCLUDE_DIR%" >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
COPY "..\..\main\%PACKAGE%\Debug\spcf-%PACKAGE%D.lib" %OUT_LIB_DIR%\ >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
COPY "..\..\main\%PACKAGE%\Release\spcf-%PACKAGE%.lib" %OUT_LIB_DIR%\ >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

ECHO [%DATE% %TIME%] ARCHIVE LIBRARY FINISH %PACKAGE%

EXIT /B 0

REM --------------------------------------------------
REM TvAvP[ṼrhRs[
REM --------------------------------------------------

:ARCHIVE_APPLICATION

REM rh
SET APPLICATION=%1
ECHO [%DATE% %TIME%] ARCHIVE APPLICATION START  %APPLICATION%

msbuild ..\..\main\app\sample\%APPLICATION%\%APPLICATION%.vcxproj /t:Clean;Build /p:configuration=RELEASE >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

REM Rs[
COPY "..\..\main\app\sample\%APPLICATION%\Release\%APPLICATION%.exe" %OUT_BIN_DIR%\ >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

RMDIR /S /Q ..\..\main\app\sample\%APPLICATION%\Debug >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
RMDIR /S /Q ..\..\main\app\sample\%APPLICATION%\Release >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
RMDIR /S /Q ..\..\main\app\sample\%APPLICATION%\ipch >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
DEL /Q ..\..\main\app\sample\%APPLICATION%\*.opensdf >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
DEL /Q ..\..\main\app\sample\%APPLICATION%\*.sdf >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED
DEL /Q ..\..\main\app\sample\%APPLICATION%\*.suo >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

XCOPY /I /E ..\..\main\app\sample\%APPLICATION% %OUT_SAMPLE_DIR%\%APPLICATION% >> "%STDOUT%" 2>> "%STDERR%"
IF %ERRORLEVEL% NEQ 0 GOTO :FAILED

ECHO [%DATE% %TIME%] ARCHIVE APPLICATION FINISH %APPLICATION%

EXIT /B 0

REM --------------------------------------------------
REM G[̏o
REM --------------------------------------------------

:FAILED

ECHO [%DATE% %TIME%] BUILD FAILED ... RETURNCODE = %ERRORLEVEL%

EXIT /B %ERRORLEVEL%
